/*
 * Name: Widget Template
 * Developer: Vinyl
 * Date: 06/12/2020
 */
define(function () {
    var html5QrcodeScanner;

    var install = function (holderElement, context) {
        // Access parameters from the context by name:
        //var testParameter = context.getParameter("TestParameter") == 'true';
        var ZXing = context.loadedDependencies[0];
        window.ZXing = ZXing;
        
        var row = context.getRow();
        var cell = context.getCell();
        
        function onScanSuccess(decodedText, decodedResult) {
            // Handle on success condition with the decoded text or result.
            console.log(`Scan result: ${decodedText}`, decodedResult);
            cell.value = decodedText;
            row.save();
        }
        
        html5QrcodeScanner = new Html5QrcodeScanner(
        	"reader", { fps: 10, qrbox: 250 });
        html5QrcodeScanner.render(onScanSuccess);
        
        /*
        // This method will trigger user permissions
        Html5Qrcode.getCameras().then(devices => {
          
          // devices would be an array of objects of type: { id: "id", label: "label" }
          if (devices && devices.length) {
            var cameraId = devices[0].id;
          }
        }).catch(err => {
          // handle err
        });
        */
        /*
        const html5QrCode = new Html5Qrcode("reader");
        html5QrCode.start(
          cameraId, 
          {
            fps: 10,    // Optional, frame per seconds for qr code scanning
            qrbox: 250  // Optional, if you want bounded box UI
          },
          (decodedText, decodedResult) => {
                console.log(decodedText)
          },
          (errorMessage) => {
            // parse error, ignore it.
          })
        .catch((err) => {
          // Start failed, handle it.
        });
        // .. use this to start scanning.
        */

        /*
        // This gets the cell the widget is attached to
        var cell = context.getCell();
        
        // Access the DOM after the view.html has been created
        var textContainer = holderElement.querySelector(".widget-template-output-text");

        // When the cell changes, get the new value
        cell.setChangeCallback('value', function (value) {
            textContainer.innerHTML = "Widget's cell has value:" + value;
        });

        // Set it once when installing.
        textContainer.innerHTML = "Widget's cell has value:" + value;

        context.setDataChangeCallback(function() {
            // Fire an event when the row changes
            if (context.isEditState()) {
                textContainer.innerHTML += "<br/>Switched to edit state";
            }
        });
        */
    };

    var uninstall = function(holderElement, context) {
        console.log("uninstall");
        html5QrcodeScanner.clear();
    };

    return {
        callbacks: {
            events: {
                // adding and removing
                
                install: install,
                uninstall: uninstall
            }
        }
    };
});
